
Foreman - Bug #5671

Stack trace due to audit table field being too short

05/12/2014 12:44 PM - Brad DeMorrow

Status: Closed   

Priority: Normal   

Assignee: Dominic Cleal   

Category: Audit Log   

Target version: 1.5.1   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases: 1.5.0

Bugzilla link: 1107701 Red Hat JIRA:  

Pull request:    

Description

I began receiving the following trace while trying to update a parameter override.

ActiveRecord::StatementInvalid

PG::StringDataRightTruncation: ERROR: value too long for type character varying(255) : INSERT INTO "audits" ("action",

"associated_id", "associated_name", "associated_type", "auditable_id", "auditable_name", "auditable_type", "audited_changes",

"comment", "created_at", "remote_address", "user_id", "user_type", "username", "version") VALUES ($1, $2, $3, $4, $5, $6, $7, $8,

$9, $10, $11, $12, $13, $14, $15) RETURNING "id"

app/models/concerns/host_common.rb:46:in `block in lookup_values_attributes='

app/models/concerns/host_common.rb:39:in `each_value'

app/models/concerns/host_common.rb:39:in `lookup_values_attributes='

app/controllers/hostgroups_controller.rb:64:in `update'

app/models/concerns/foreman/thread_session.rb:33:in `clear_thread'

lib/middleware/catch_json_parse_errors.rb:9:in `call'

The parameter I'm updating contained usernames and their sha512 hashes.

Related issues:

Related to Foreman - Bug #1902: Smart Parameters aren't audit logged Closed 10/17/2012

Has duplicate Foreman - Bug #5721: Updating host group parameter in 1.5.0 giv... Duplicate 05/14/2014

Has duplicate Foreman - Bug #5762: Multiple matchers on smart variable Duplicate 05/16/2014

Has duplicate Foreman - Bug #5807: PGError: "value too long for type characte... Duplicate 05/20/2014

Has duplicate Foreman - Bug #6087: input into audit goes wrong Duplicate 06/06/2014

Has duplicate Foreman - Bug #6280: crash adding a smart variable matcher Duplicate 06/18/2014

Associated revisions

Revision 9158ff3c - 05/22/2014 09:26 AM - Dominic Cleal

fixes #5671 - LookupValue name should be matcher, value is too long

Revision 72bea991 - 06/11/2014 01:02 PM - Dominic Cleal

fixes #5671 - LookupValue name should be matcher, value is too long

(cherry picked from commit 9158ff3ca56d39cc399a5aa35dd04c3b3d78ff1a)

History

#1 - 05/12/2014 12:47 PM - Brad DeMorrow

sudo -u foreman psql -c '\d audits'

                                        Table "public.audits" 

     Column      |            Type             |                      Modifiers

-----------------+-----------------------------+-----------------------------------------------------

 id              | integer                     | not null default nextval('audits_id_seq'::regclass)

 auditable_id    | integer                     |

 auditable_type  | character varying(255)      |

 user_id         | integer                     |

 user_type       | character varying(255)      |
 username        | character varying(255)      |

 action          | character varying(255)      |

 audited_changes | text                        |

 version         | integer                     | default 0

 comment         | character varying(255)      |

 associated_id   | integer                     |

 associated_type | character varying(255)      |

 created_at      | timestamp without time zone |

 remote_address  | character varying(255)      |

 auditable_name  | character varying(255)      |

 associated_name | character varying(255)      |

Indexes:

    "audits_pkey" PRIMARY KEY, btree (id)

    "associated_index" btree (associated_id, associated_type)

    "auditable_index" btree (auditable_id, auditable_type)

    "auditable_parent_index" btree (associated_id, associated_type)

    "index_audits_on_created_at" btree (created_at)

    "index_audits_on_id" btree (id)

    "user_index" btree (user_id, user_type)

Foreign-key constraints:

    "audits_user_id_fk" FOREIGN KEY (user_id) REFERENCES users(id)

#2 - 05/12/2014 12:48 PM - Dominic Cleal

- Related to Bug #1902: Smart Parameters aren't audit logged added

#3 - 05/12/2014 12:48 PM - Dominic Cleal

- Category set to Audit Log

- translation missing: en.field_release set to 16

#4 - 05/12/2014 12:54 PM - Brad DeMorrow

After a little bit of digging, it looks like auditable_name is the culprit.

#5 - 05/12/2014 02:41 PM - Dominic Cleal

- Status changed from New to Ready For Testing

- Assignee set to Dominic Cleal

- Target version set to 1.8.3

https://github.com/theforeman/foreman/pull/1437

#6 - 05/14/2014 03:15 PM - Dominic Cleal

- Has duplicate Bug #5721: Updating host group parameter in 1.5.0 give value too long for type character varying(255) added

#7 - 05/16/2014 04:33 PM - Dominic Cleal

- Has duplicate Bug #5762: Multiple matchers on smart variable added

#8 - 05/19/2014 12:43 PM - Anonymous

- Target version changed from 1.8.3 to 1.8.2

#9 - 05/20/2014 07:13 AM - Dominic Cleal

- Has duplicate Bug #5807: PGError: "value too long for type character varying(255)" for INSERT INTO "audits" when overriding "smart variable" in

hostgroup with  >255 characters value. added

#10 - 05/22/2014 09:31 AM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 9158ff3ca56d39cc399a5aa35dd04c3b3d78ff1a.

#11 - 06/06/2014 09:09 AM - Dominic Cleal

- Has duplicate Bug #6087: input into audit goes wrong  added
https://github.com/theforeman/foreman/pull/1437
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/9158ff3ca56d39cc399a5aa35dd04c3b3d78ff1a


#12 - 06/10/2014 12:53 PM - Bryan Kearney

- Bugzilla link set to https://bugzilla.redhat.com/show_bug.cgi?id=1107701

#13 - 06/19/2014 07:25 AM - Dominic Cleal

- Has duplicate Bug #6280: crash adding a smart variable matcher added
